using System.Collections;
using System.Collections.Generic;
using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Video;
using UnityEngine.SceneManagement;
using Orgil;

public enum GameTp {
    SUBBNO2, SUBBNO5, SUBBNO6, SUBHEM3, SUBHEM6, SUBHYA2, SUBHYA3, SUBHYA4, SUBHYA6, SUBHYA8,
    BBHBO1, BBHBO2, BBHBO3, BBHBO4, BBHBO5, BBHBO6, BBHBO7, BBHBO8, BBHBO9, BBHBO10,
}
public class GameData {
    public Name lesson;
    int grd;
    bool isBlindVid;
    public string title => names[0][0].txt;
    public string grade => grd > 0 ? grd + Name.angi.txt : (5 + grd) + Name.nas.txt;
    public string video => "https://medle.mn/interactive/videos/" + Song.game + "/" + Song.game + "_" + "MKTDH"[!isBlindVid && Song.IsBlind ? 0 : Song.tp] + ".mp4";
    public Vector3 bidoPos, lbPos;
    public bool isSignCirc;
    public Dictionary<string, float> lenDic;
    public List<List<Name>> names;
    public GameData(int grd, Name lesson, bool isBlindVid,
        Vector3 bidoPos, float lbPosY, bool isSignCirc,
        Dictionary<string, float> lenDic,
        List<List<Name>> names) {
        this.lesson = lesson;
        this.grd = grd;
        this.isBlindVid = isBlindVid;
        this.bidoPos = bidoPos;
        lbPos = V2.Y(lbPosY);
        this.isSignCirc = isSignCirc;
        this.lenDic = lenDic;
        this.names = names;
    }
}
public class LvlData {
    public GameObject go;
    public Vector3 staP;
    public Text txt;
    public LvlData(GameObject lvlGo) {
        go = lvlGo;
        staP = lvlGo.Tp();
        txt = lvlGo.ChildName("Question", "Text").Txt();
    }
}
[System.Serializable]
public class Name {
    public string mongol, kazak, tuva;
    public string txt {
        get {
            string s = Song.IsKazak ? kazak : Song.IsTuva ? tuva : mongol;
            return s == "" ? mongol : s;
        }
    }
    public string txtU => txt.ToUpper(CultureInfo.CreateSpecificCulture("kk-KZ"));
    public Name(string mongol, string kazak, string tuva) {
        this.mongol = mongol;
        this.kazak = kazak;
        this.tuva = tuva;
    }
    public static Name ehleh = new Name("Эхлэх", "Бастау", "Эгелээри"),
        angi = new Name("-р анги", "-сынып", " дугаар анги"),
        nas = new Name(" нас", " жас", " чаш"),
        uyeSongo = new Name("Тоглоомын үеэ сонгоно уу.", "Ойынның кезеңін таңда.", "Оюннуң үезин соңгугар."),
        duusah = new Name("ДУУСАХ", "АЯҚТАУ", "ДООСТУУН"),
        amjilttai = new Name("Амжилттай", "Бәрекелді", "Амжилталыг"),
        nuurHuudas = new Name("Нүүр хуудас", "Басқы бет", "Башкы арын"),
        BNO = new Name("Байгаль, нийгмийн орчин", "Табиғат және қоршаған орта", "Бойдус, ниитилел хүрээлели"),
        HEM = new Name("Хөдөлгөөн, эрүүл мэнд", "Дене шынықтыру, денсаулық", "Шимчээшкин, кадыкшыл"),
        HYA = new Name("Хэл яриа", "Тіл дамыту", "Дыл, чугаа"),
        HBO = new Name("Хүн ба орчин", "Адам және қоршаған орта", "Кижи болгаш хүрээлел");
}
[System.Serializable]
public class Song {
    public static int tp {
        get { return PlayerPrefs.GetInt(nameof(Song), 0); }
        set {
            PlayerPrefs.SetInt(nameof(Song), value);
            IsSign = value == 3;
            IsBlind = value == 4;
            IsMongol = value != 1 && value != 2;
            IsKazak = value == 1;
            IsTuva = value == 2;
        }
    }
    public static int tp2 => tp >= 3 ? 0 : tp;
    public static GameTp game {
        get { return PlayerPrefs.GetString("Game").Enum<GameTp>(); }
        set { PlayerPrefs.SetString("Game", "" + value); }
    }
    public static GameData data => Dic[game];
    public static List<List<Name>> txts => Dic[game].names;
    public static bool IsSign, IsBlind, IsMongol, IsKazak, IsTuva;
    public AudioClip clip;
    public float len, clipLen;
    public string sign;
    public Song(string path, string s) {
        if (!path.IsE("/")) path += "/";
        clip = O.LoadClip(path + (tp == 1 ? "k" : tp == 2 ? "t" : "m") + s);
        path = path.Replace("Data/", "");
        float vidLen = IsSign && data.lenDic.ContainsKey("d" + s) ? data.lenDic["d" + s] : 1;
        clipLen = clip ? clip.length : 1;
        len = IsSign ? (clip ? M.Max(vidLen, clip.length) : vidLen) : clipLen;
        sign = path + "d" + s;
        // VideoClip vc = O.Load<VideoClip>("StreamingAssets/" + sign);
        // if (vc) SignStr += "{\"" + s + "\", " + (float)vc.length + "f}, ";
    }
    // static string SignStr = "";
    // public static void PrintSign() { Debug.Log(SignStr); }
    public static void Strs(string path, string s, ref List<string> strs) {
#if UNITY_EDITOR
        if (O.LoadClip(path + "m" + s)) strs[1] += s + ", ";
        if (O.LoadClip(path + "k" + s)) strs[2] += s + ", ";
        if (O.LoadClip(path + "t" + s)) strs[3] += s + ", ";
#endif
    }
    static Dictionary<GameTp, GameData> Dic = new Dictionary<GameTp, GameData> {
        { GameTp.SUBBNO2, new GameData(-1, Name.BNO, true, V3.Xy(540, 140), 320, true, new Dictionary<string, float> {
                {"d", 7.56f}, {"d1", 15.52f}, {"d2", 6.16f}, {"d_", 5.4f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Өдөр, шөнө хэрхэн ээлжилдэг вэ?",
                        "Күн мен түн қалай ауысады?",
                        "Хүн, дүн канчап ээлчилээр?"
                    ), new Name(
                        "Зургийг сайтар ажиглаад эвлүүлээрэй.",
                        "Суреттерге мұқият қарап, оларды құрастыр.",
                        "Чурукту экитир көргеш, эвилештиргер."
                    ), new Name(
                        "Өдөр, шөнө хийдэг үйлийг ялгаарай.",
                        "Күндіз және түнде не болатынын ажырат.",
                        "Хүндүс, дүне кылыр кылдыныгны ылгагар."
                    ),
                },
            })
        }, { GameTp.SUBBNO5, new GameData(0, Name.BNO, false, V3.Xy(-530, 0), 310, true, new Dictionary<string, float> {
                {"d1", 10.6f}, {"d1b1", 2.84f}, {"d1b2", 3.48f}, {"d1b3", 4.72f}, {"d1z1", 3.76f}, {"d1z2", 4.28f}, {"d1z3", 4.16f}, {"d1z4", 3.8f}, {"d1z5", 3.24f}, {"d2", 5.92f}, {"d2b1", 2.28f}, {"d2b2", 2.2f}, {"d2b3", 3.08f}, {"d2b4", 3.36f}, {"d2b5", 3.92f}, {"d2z1", 3.24f}, {"d2z2", 3.8f}, {"d2z3", 3.12f}, {"d2z4", 3.56f}, {"d2z5", 4.44f}, {"d2z6", 2.88f}, {"d3", 6.12f}, {"d3b1", 3.12f}, {"d3b2", 2.96f}, {"d3b3", 3.4f}, {"d3b4", 2.76f}, {"d3b5", 3.12f}, {"d3z1", 2.44f}, {"d3z2", 2.6f}, {"d3z3", 3.36f}, {"d3z4", 2.76f}, {"d3z5", 2.76f}, {"d3z6", 2.8f}, {"d3z7", 2.52f}, {"d_", 3.8f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Би удахгүй сургуульд орно",
                        "Мен мектепке барамын",
                        "Мен удавас сургуулга кирер мен"
                    ), new Name(
                        "Аль нь сургуулийн гадна байдаг тэмдэг, тэмдэглэгээ вэ?",
                        "Қайсысы мектептің ауласында болатын белгілер?",
                        "Кайсы сургуулдуң чаштындаа турар демдегил?"
                    ), new Name(
                        "Сургууль дотор ямар, ямар өрөө байдаг вэ?",
                        "Мектепте қандай, қандай бөлмелер болады?",
                        "Сургуул иштинде кандыг, кандыг өрээ турар ирги?"
                    ), new Name(
                        "Сургуульд ямар ажил, мэргэжилтэй хүмүүс ажилладаг вэ?",
                        "Мектепте қандай маманды адамдар жұмыс істейді?",
                        "Сургуулда кандыг мергежилдиг кижилер ажылдаар?"
                    ),
                },
            })
        }, { GameTp.SUBBNO6, new GameData(-1, Name.BNO, false, V3.Xy(560, 260), 320, false, new Dictionary<string, float> {
                {"d1_1", 7.1f}, {"d1_2", 6.033f}, {"d2", 6.067f}, {"d3", 6.367f}, {"d_", 5.9f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Цас, бороо яагаад ордог вэ?",
                        "Қар мен жаңбыр неге жауады?",
                        "Хар, чаашкын чүге чаар?"
                    ), new Name(
                        "Бороо орох дарааллыг зөв болгоно уу.",
                        "Жаңбырдың жауу ретін орнына келтір.",
                        "Чаашкын чаар дараалалды чиге тургускар."
                    ), new Name(
                        "Цас орох дарааллыг зөв болгоно уу.",
                        "Қардың жауу ретін орнына келтір.",
                        "Хар чаар дараалалды чиге тургускар."
                    ), new Name(
                        "Зургийг тохирох хэсэгт байрлуулаарай.",
                        "Суретті тиісті жеріне орналастыр.",
                        "Чурукту таарыыр кезээнге тургускар."
                    ), new Name(
                        "Зургийг сайтар ажиглаад эвлүүлээрэй.",
                        "Суреттерге мұқият қарап, оларды құрастыр.",
                        "Чурукту экитир көргеш, эвилештиргер."
                    ),
                },
            })
        }, { GameTp.SUBHEM3, new GameData(-1, Name.HEM, false, V3.Xy(-530, 0), 310, true, new Dictionary<string, float> {
                {"d1", 5.28f}, {"d1b1", 3.96f}, {"d1b2", 2.36f}, {"d1b3", 3.36f}, {"d1z1", 3.56f}, {"d1z2", 3.6f}, {"d1z3", 3.52f}, {"d2", 4.8f}, {"d2b1", 1.72f}, {"d2b2", 2.76f}, {"d2b3", 4.88f}, {"d2t", 18.68f}, {"d2z1", 3.92f}, {"d2z2", 2.16f}, {"d3", 3.8f}, {"d3b1", 2.72f}, {"d3b2", 1.8f}, {"d3b3", 3.08f}, {"d3z1", 2f}, {"d4", 5.48f}, {"d4b1", 3.24f}, {"d4b2", 4.4f}, {"d4b3", 2.56f}, {"d4z1", 3.68f}, {"d4z2", 3.16f}, {"d4z3", 3.36f}, {"d5", 6.96f}, {"d5b1", 2.52f}, {"d5b2", 2.84f}, {"d5b3", 3.28f}, {"d5z1", 4f}, {"d5z2", 2.84f}, {"d5z3", 3.68f}, {"d6", 5.44f}, {"d6b1", 3.8f}, {"d6b2", 2.72f}, {"d6b3", 2.96f}, {"d6t", 15.24f}, {"d6z1", 4.2f}, {"d6z2", 3.52f}, {"d6z3", 2.68f}, {"d7", 5.2f}, {"d7b1", 3.56f}, {"d7b2", 4.32f}, {"d7b3", 4.28f}, {"d7z1", 8.8f}, {"d7z2", 9f}, {"d7z3", 4.08f}, {"d_", 4.2f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Үер, уснаас болгоомжилъё",
                        "Су апатынан сақ болайық",
                        "Үер, сугнан болгааныыкай"
                    ), new Name(
                        "Голын усанд эд зүйлээ унагавал яах вэ?",
                        "Тоқтау суға бір нәрсеңді түсіріп алсаң қайтесің?",
                        "Хемниң суунга чүвезин ышкынып алса, канчаар?"
                    ), new Name(
                        "Тогтоол усанд тоглож болох уу?",
                        "Тоқтау суға ойнауға болама?",
                        "Доктаап каан сугга ойнап болур ба?"
                    ), new Name(
                        "Үер болсон үед аль дугаар луу залгах вэ?",
                        "Су апаты болған кезде қандай нөмірге хабарласу керек?",
                        "Үер болган үеде кай дугаар куду чалгаар?"
                    ), new Name(
                        "Аянга цахилгаантай бороо орж байхад хаана байх нь зөв бэ?",
                        "Найзағай ойнап, жаңбыр жауып тұрса қайда болу керек?",
                        "Алдай ыыттаан чаашкынныг үеде каяа турары чөп?"
                    ), new Name(
                        "Дуутай ширүүн бороо орж байгаа үед юу хийж болохгүй вэ?",
                        "Жаңбыр қатты жауған кезде не істеуге болмайды?",
                        "Ыыттыг күштүг чаашкын чаап турарда, чүнү кылып болбас?"
                    ), new Name(
                        "Үер болбол чи юу хийх вэ?",
                        "Су тасқыны болса не істейсің?",
                        "Үер болса, сен чүнү кылыр сен?"
                    ), new Name(
                        "Үер усны аюулаас гэр бүлээрээ хэрхэн сэргийлэх вэ?",
                        "Отбасымызбен су тасқынынан қалай сақтануға болады?",
                        "Үер сугнуң айыылынан өг-бүлезинен канчап хамгаалаар?"
                    ),
                },
            })
        }, { GameTp.SUBHEM6, new GameData(0, Name.HEM, false, V3.Xy(-530, 0), 310, true, new Dictionary<string, float> {
                {"d1", 5.28f}, {"d10", 5.8f}, {"d10b1", 3.88f}, {"d10b2", 4.56f}, {"d10b3", 3.92f}, {"d10b4", 3.16f}, {"d10z1", 6.04f}, {"d10z2", 5.76f}, {"d10z3", 5.92f}, {"d10z4", 4.08f}, {"d10z5", 3.88f}, {"d10z6", 5.24f}, {"d1b1", 2.24f}, {"d1b2", 2.56f}, {"d1b3", 2.16f}, {"d1b4", 2.96f}, {"d1z1", 2.68f}, {"d1z2", 2.6f}, {"d2", 6.24f}, {"d2b1", 2.68f}, {"d2b2", 3.12f}, {"d2b3", 2.48f}, {"d2b4", 2.24f}, {"d2b5", 2.2f}, {"d2z1", 4.8f}, {"d2z2", 4.56f}, {"d3", 5.04f}, {"d3b1", 2.68f}, {"d3b2", 2.72f}, {"d3b3", 3.68f}, {"d3b4", 2.6f}, {"d3z1", 2.48f}, {"d4", 6.52f}, {"d4b1", 4.16f}, {"d4b2", 3.12f}, {"d4b3", 2.8f}, {"d4b4", 4f}, {"d4z1", 3f}, {"d4z2", 4.68f}, {"d4z3", 4.32f}, {"d5", 5.16f}, {"d5b1", 3.8f}, {"d5b2", 5.12f}, {"d5b3", 5.04f}, {"d5b4", 4.96f}, {"d5b5", 4.2f}, {"d5b6", 3.56f}, {"d5z1", 3.92f}, {"d5z2", 3f}, {"d6", 4.92f}, {"d6b1", 5.8f}, {"d6b2", 3.56f}, {"d6b3", 3.92f}, {"d6b4", 4.16f}, {"d6b5", 3f}, {"d6b6", 5.68f}, {"d6z1", 5.76f}, {"d6z2", 4.48f}, {"d7", 5.72f}, {"d7b1", 4f}, {"d7b2", 3.16f}, {"d7z1", 3.24f}, {"d7z2", 3.72f}, {"d7z3", 3.92f}, {"d8", 5.08f}, {"d8b1", 2.28f}, {"d8b2", 3.04f}, {"d8b3", 2.48f}, {"d8b4", 3.92f}, {"d8b5", 3.56f}, {"d8z1", 7.32f}, {"d9", 4.68f}, {"d9b1", 3.68f}, {"d9b2", 2.68f}, {"d9b3", 3.36f}, {"d9b4", 2.64f}, {"d9z1", 4.4f}, {"d_", 3.12f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Гал түймрээс болгоомжилъё",
                        "Өрттен сақ болайық",
                        "Өрттен болгааныыкай"
                    ), new Name(
                        "Гал гаргах хэрэгсэл аль нь вэ?",
                        "Қайсысы от тамызғыш?",
                        "Кайсы өрт үндүрер херексел?"
                    ), new Name(
                        "Гал унтраахад аль нь хэрэгтэй вэ?",
                        "Өртті сөндіру үшін қайсысы қажет?",
                        "Өрттү өжүрерде, кайсы херектиг?"
                    ), new Name(
                        "Гал гарвал аль дугаарт залгах вэ?",
                        "Өрт шықса қандай нөмірге хабарласу керек?",
                        "Өрт үнсе, кай дугаар куду чалгаар?"
                    ), new Name(
                        "Гал, утаа гарвал ямар тэмдэг дагаж гадагш гарах вэ?",
                        "Өрт немесе түтін шықса қандай белгілер арқылы сыртқа шығу керек?",
                        "Өрт билен ыш үнсе, кандыг демдекти эдерип чашкаар үнер?"
                    ), new Name(
                        "Гал түймэр гарсан үед аль үйлдлийг хийж болохгүй вэ?",
                        "Өрт шыққан кезде не істеуге болмайды?",
                        "Өрт үнген үеде кайсын кылып болбас?"
                    ), new Name(
                        "Гал гарсан тохиолдолд аль үйлдлийг хийх нь зөв бэ?",
                        "Өрт шыққан кезде қандай шара қолданған дұрыс?",
                        "Өрт үнген үеде кайсын кылыры чөп?"
                    ), new Name(
                        "Хувцас шатаж эхэлсэн үед яагаад гүйж болохгүй вэ?",
                        "Киімің өтрене бастағанда неліктен жүгіруге болмайды?",
                        "Эдик хеп өрттенип эгелээн үеде чүге чүгүрүп болбас?"
                    ), new Name(
                        "Гал гарсан үед ямар дүрэм баримтлах вэ?",
                        "Өрт шыққан кезде қандай ережелерді ұстау керек?",
                        "Өрт үнген үеде кандыг дүрүмнү тудар?"
                    ), new Name(
                        "Хэрвээ хувцас чинь галд өртвөл ямар дүрэм баримтлах вэ?",
                        "Киімің өртенсе қандай ереже ұстануың керек?",
                        "Бир эмес эдик хеп өртенсе, кандыг дүрүмнү тудар?"
                    ), new Name(
                        "Жижгээ өөрийгөө галаас хэрхэн аврах вэ?",
                        "Жижгээ өзін өрттен қалай құтқаруға болады?",
                        "Жижгээ өрттен бодун канчап ап, үнер?"
                    ),
                },
            })
        }, { GameTp.SUBHYA2, new GameData(-1, Name.HYA, false, V3.Xy(-530, 0), 310, false, new Dictionary<string, float> {
                {"d", 5.64f}, {"d1_1", 2.84f}, {"d1_2", 3.08f}, {"d1_3", 3.24f}, {"d2_1", 2.72f}, {"d2_2", 2.52f}, {"d2_3", 3.6f}, {"d2_4", 2.84f}, {"d2_5", 2.88f}, {"d3_1", 3.4f}, {"d3_2", 3.76f}, {"d3_3", 3.04f}, {"d3_4", 3.2f}, {"d3_5", 3f}, {"d3_6", 3.72f}, {"d_", 4.36f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Үгийн баялгаа нэмэгдүүлье",
                        "Сөздік қорымызды молайтайық",
                        "Көвей сөс билип алаакай"
                    ), new Name(
                        "Ижил картыг олоорой.",
                        "Картардың жұбын тап.",
                        "Дөөй картыны тыпкар."
                    ),
                },
            })
        }, { GameTp.SUBHYA3, new GameData(-1, Name.HYA, false, V3.Xy(-530, 0), 310, false, new Dictionary<string, float> {
                {"d1", 5.96f}, {"d1_1", 2.88f}, {"d1_2", 2.96f}, {"d1_3", 2.52f}, {"d1_4", 2.8f}, {"d1_5", 2.24f}, {"d2", 6.8f}, {"d2_1", 2.96f}, {"d2_2", 2.24f}, {"d2_3", 2.44f}, {"d2_4", 2.8f}, {"d3_1", 2.2f}, {"d4_honh_duugarlaa", 3.32f}, {"d4_nom_surlaa", 3.2f}, {"d4_ongots_buulaa", 3f}, {"d4_solongo_harlaa", 3.36f}, {"d4_tsagaan_ongots_buulaa", 4.36f}, {"d_", 3.56f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Өгүүлбэр бүтээе",
                        "Сөйлем құрайық",
                        "Домак чогаадыыкай"
                    ), new Name(
                        "Өгүүлбэрийг сонсоод, зургийг холбоорой.",
                        "Сөйлемдерді тыңдап, суреттерді сәйкестір.",
                        "Домакты дыңнааш, чурукту холбагар."
                    ), new Name(
                        "Зургийг зөв дараалалд оруулж, өгүүлбэр бүтээгээрэй.",
                        "Суреттерді дұрыс орналастырып, сөйлем құра.",
                        "Чурукту чиге дараалалга кииргеш, домак чогааткар."
                    ),
                },
            })
        }, { GameTp.SUBHYA4, new GameData(-1, Name.HYA, true, V3.Xy(-530, 0), 310, true, new Dictionary<string, float> {
                {"d1", 8.76f}, {"d2", 8.48f}, {"d3", 13.96f}, {"d_", 7.36f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Үйл явдлын дарааллыг олъё",
                        "Оқиғалардың ретін табайық",
                        "Болуушкуннуң дараалалын тываакай"
                    ), new Name(
                        "Түрүүн үзсэн бичлэг дэх үйл явдлын дагуу зургийг зөв байрлуулаарай.",
                        "Алдыңғы бейнежазбадағы оқиғаларға сәйкес суреттерді дұрыс орналастыр.",
                        "Мурнунда көрген бичликдээги болуушкун аайынан чурукту чиге тургускар."
                    ), new Name(
                        "Зургуудыг зургийн цомгийн дарааллын дагуу байрлуулаарай.",
                        "Фотосуреттерді фотоальбомдағы рет бойынша орналастыр.",
                        "Чуруктарны чурук альбомунда дараалал аайынан тургускар."
                    ), new Name(
                        "Зургийг эвлүүлээд, Томоо, Жижгээ хоёр юу хийж байгааг гэрийнхэндээ ярьж өгөөрэй.",
                        "Суреттерді сәйкестіріп, отбасыңдағыларыңа Томоо мен Жижгээнің не істеп жатқандарын айтып бер.",
                        "Чурукту эвилештиргеш, Томоо, Жижгээ ийи чүнү кылып турарын өөгерде улуска аайтып бергер."
                    ),
                },
            })
        }, { GameTp.SUBHYA6, new GameData(0, Name.HYA, false, V3.Xy(-530, 0), 320, true, new Dictionary<string, float> {
                {"dEnd", 6.88f}, {"d_", 5.64f}, {"de", 8.52f}, {"de10a", 3.88f}, {"de10b", 3.64f}, {"de11a", 2.8f}, {"de11b", 3.64f}, {"de12a", 2.92f}, {"de12b", 3.92f}, {"de1a", 3.042f}, {"de1b", 2.88f}, {"de2a", 2.88f}, {"de2b", 3.2f}, {"de3a", 3.64f}, {"de3b", 3.44f}, {"de4a", 3.24f}, {"de4b", 2.96f}, {"de5a", 2.92f}, {"de5b", 3.92f}, {"de6a", 3.72f}, {"de6b", 3f}, {"de7a", 2.68f}, {"de7b", 3.36f}, {"de8a", 3.8f}, {"de8b", 2.92f}, {"de9a", 3.92f}, {"de9b", 3.84f}, {"di", 8.68f}, {"di1a", 3.32f}, {"di1b", 3.64f}, {"di2a", 3.08f}, {"di2b", 3.84f}, {"di3a", 3.92f}, {"di3b", 3.76f}, {"di4a", 3.84f}, {"di4b", 4.12f}, {"di5a", 2.92f}, {"di5b", 3f}, {"di6a", 3.28f}, {"di6b", 3.88f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Ижил үү, эсрэг үү?",
                        "Бірдей ме, қарама-қарсы ма?",
                        "Дөөй бе, удур ба?"
                    ), new Name(
                        "Эсрэг утга илэрхийлж байгаа зургийг олж холбоорой.",
                        "Мағынасы қарама-қарсы суретті тауып, сәйкестір.",
                        "Удур утка илередип турар чурукту тыпкаш, холбагар."
                    ), new Name(
                        "Ижил утга илэрхийлж байгаа зургийг олж холбоорой.",
                        "Мағынасы бірдей суреттерді тауып, сәйкестір.",
                        "Дөөй утка илередип турар чурукту тыпкаш, холбагар."
                    ),
                },
            })
        }, { GameTp.SUBHYA8, new GameData(0, Name.HYA, false, V3.Xy(-530, 130), 320, true, new Dictionary<string, float> {
                {"d1", 7.4f}, {"d2", 9.4f}, {"d3", 9.52f}, {"d_", 4.56f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Сонирхолтой тэмдэг, тэмдэглэгээ",
                        "Қызықты белгілер",
                        "Сонирхалдыг демдектер"
                    ), new Name(
                        "Жижгээг зам хөндлөн гарахад туслаарай.",
                        "Жижгээнің жолдан өтуіне көмектес.",
                        "Жижигээге орук кежеринге дузалагар."
                    ), new Name(
                        "Эхний баганыг ажиглаж, ижил тэмдэглэгээг дараарай.",
                        "Бірінші бағанаға мұқият қарап, бірдей белгіні бас.",
                        "Баштайгы багананы экитир көргеш, дөөй демдектерни баскар."
                    ), new Name(
                        "Тэмдэг, тэмдэглэгээг тохирох газар нь байрлуулаарай.",
                        "Білгілерді сәйкес орынға орналастыр.",
                        "Демдектерни таарыыр черинге тургускар."
                    ),
                },
            })
        }, { GameTp.BBHBO1, new GameData(1, Name.HBO, false, V3.Xy(540, 260), 320, true, new Dictionary<string, float> {
                {"d1_1", 10.76f}, {"d1_2", 8.16f}, {"d1_3", 9f}, {"d2", 9.88f}, {"d3", 13.12f}, {"d3t", 17.12f}, {"d_", 9f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Өдрийн дэглэмийн ач тус",
                        "Күн тәртібінің пайдасы",
                        "Хүн дэглэминиң ажык дузазы"
                    ), new Name(
                        "Айдогийн өдрийн дэглэмийг зөв дараалалд оруулаарай.",
                        "Айдоның күн тәртібін дұрыс ретке келтір.",
                        "Айдонуң хүн демдеглелин чиге дараалалга кииргер."
                    ), new Name(
                        "Мидогийн өдрийн дэглэмийг зөв дараалалд оруулаарай.",
                        "Мидоның күн тәртібін дұрыс ретке келтір.",
                        "Мидонуң хүн демдеглелин чиге дараалалга кииргер."
                    ), new Name(
                        "Кидогийн өдрийн дэглэмийг зөв дараалалд оруулаарай.",
                        "Кидоның күн тәртібін дұрыс ретке келтір.",
                        "Кидонуң хүн демдеглелин чиге дараалалга кииргер."
                    ), new Name(
                        "Зургийг ажиглаад зөв харгалзуулаарай.",
                        "Суретке мұқият қарап, дұрыс сәйкестір.",
                        "Чурукту көргеш, чиге холбагар."
                    ), new Name(
                        "Зургийг ашиглан өөрийн өдрийн дэглэмийг бүтээгээрэй.",
                        "Суретті пайдаланып өзіңізнің күн тәртәбіңді жаса.",
                        "Чурукту ажыглап, бодугарның хүн демдеглелин чогааткар."
                    ), new Name(
                        "ӨГЛӨӨ",
                        "Тәңертең",
                        "Даңмылан"
                    ), new Name(
                        "ӨДӨР",
                        "Күндіз",
                        "Дүъш"
                    ), new Name(
                        "ОРОЙ",
                        "Кешке",
                        "Кежээ"
                    ),
                }, new List<Name> {
                    new Name(
                        "Өглөө босно",
                        "Таңертең тұрамын",
                        "Даңмылан турар"
                    ), new Name(
                        "Өглөө нүүр, гар, шүдээ угаана",
                        "Таңертең бетімді, қолымды және тісімді жуамын",
                        "Даңмылан арын, хол, дижин чуур"
                    ), new Name(
                        "Өглөөний цайгаа ууна",
                        "Таңғы асымды ішемін",
                        "Даңмылангы шай ижер"
                    ), new Name(
                        "Зураг зурна",
                        "Сурет саламын",
                        "Чурук чуруур"
                    ), new Name(
                        "Цэцгээ усална",
                        "Гүл суарамын",
                        "Чечек суггарар"
                    ), new Name(
                        "Өдрийн хоолоо иднэ",
                        "Түскі асымды ішемін",
                        "Дүъшкү чем чиир"
                    ), new Name(
                        "Цахим хичээлдээ сууна",
                        "Онлайн сабаққа қатысамын",
                        "Цахим кичээлге олурар"
                    ), new Name(
                        "Өрөөгөө цэвэрлэнэ",
                        "Бөлмемді тазалаймын",
                        "Өрээ шеверлээр"
                    ), new Name(
                        "Оройн хоолоо иднэ",
                        "Кешкі асымды ішемін",
                        "Кежээки чемин чиир"
                    ), new Name(
                        "Шүдээ угаагаад унтана",
                        "Тісімді жуып жатамын",
                        "Диш чуггаш, удуур"
                    ),
                }, new List<Name> {
                    new Name(
                        "Өглөө босно",
                        "Тәңертең тұрамын",
                        "Даңмылан турар"
                    ), new Name(
                        "Өглөө нүүр гар, шүдээ угаана",
                        "Таңертең бетімді, қолымды және тісімді жуамын",
                        "Даңмылан арын, хол, дижин чуур"
                    ), new Name(
                        "Өглөөний цайгаа ууна",
                        "Таңғы асымды ішемін",
                        "Даңмылангы шай ижер"
                    ), new Name(
                        "Тэргэнцрээ супер болгох арга судална",
                        "Арбамды супер қылатын амал қарастырамын",
                        "Тергенин супер кылыр арга судулаар"
                    ), new Name(
                        "Судалсан аргуудаа тэргэнцэр дээрээ туршиж үзнэ",
                        "Қарастырып тапқан амалды арбама қорлоданып көремін",
                        "Судулаан аргаларын тергенге туршип көөр"
                    ), new Name(
                        "Оройн хоолоо иднэ",
                        "Кешкі асымды ішемін",
                        "Кежээки чем чиир"
                    ), new Name(
                        "Өдрийн тэмдэглэлээ хөтөлнө",
                        "Күнделік жазамын",
                        "Хүн демдеглелин бижиир"
                    ), new Name(
                        "Шүдээ угаагаад унтана",
                        "Тісімді жуып жатамын",
                        "Дижин чуггаш, удуур"
                    ),
                }, new List<Name> {
                    new Name(
                        "Өглөө босно",
                        "Тәңертең тұрамын",
                        "Даңмылан турар"
                    ), new Name(
                        "Өглөө нүүр гар, шүдээ угаана",
                        "Таңертең бетімді, қолымды және тісімді жуамын",
                        "Даңмылан арын, хол, дижин чуур"
                    ), new Name(
                        "Өглөөний цайгаа ууна",
                        "Таңғы асымды ішемін",
                        "Даңмылангы шай ижер"
                    ), new Name(
                        "Дасгал хийнэ",
                        "Жаттығу жасаймын",
                        "Дасгал кылыр"
                    ), new Name(
                        "Хөгжим сонсоно",
                        "Музыка тыңдаймын",
                        "Хөгжүм дыңнаар"
                    ), new Name(
                        "Өдрийн хоолоо иднэ",
                        "Түскі асымды ішемін",
                        "Дүъшкү чемин чиир"
                    ), new Name(
                        "Цахим хичээлээ хийнэ",
                        "Онлайн сабаққа қатысыман",
                        "Цахим кичээл кылыр"
                    ), new Name(
                        "Дуртай тоглоомоороо тоглоно",
                        "Ұнататын ойынымды ойнаймын",
                        "Дуралыг оюннан ойнаар"
                    ), new Name(
                        "Оройн хоолоо иднэ",
                        "Кешкі асымды ішемін",
                        "Кежээки чемин чиир"
                    ), new Name(
                        "Шүдээ угаагаад унтана",
                        "Тісімді жуып жатамын",
                        "Дижин чуггаш, удуур"
                    ),
                }, new List<Name> {
                    new Name(
                        "Өглөөний 08-09 цагт",
                        "Тәңертеңгі 08-09 сағат аралығында",
                        "Даңмылангы 08-09 шагда"
                    ), new Name(
                        "Өглөө босоод, дасгалаа хийнэ",
                        "Таңертең тұрып, жаттығу жасаймын",
                        "Даңмылан тургаш, дасгалын кылыр"
                    ), new Name(
                        "Өглөөний цайгаа ууна",
                        "Таңғы асымды ішемін",
                        "Даңмылангы шай ижер"
                    ), new Name(
                        "Өглөө босоод нүүр гар, шүдээ угаана",
                        "Таңертең тұрып бетімді, қолымды және тісімді жуамын",
                        "Даңмылан тургаш, арын, хол, дижин чуур"
                    ), new Name(
                        "Хичээлийн бэлтгэлээ хангана",
                        "Сабаққа барауға дайындаламын",
                        "Кичээлдиң белеткелин кылыр"
                    ),
                }, new List<Name> {
                    new Name(
                        "Өдрийн 11-13 цагт",
                        "Күндіз 11-13 сағат аралығында",
                        "Дүъшкү 11-13 шагда"
                    ), new Name(
                        "Өдрийн 12-13 цагт",
                        "Күндіз 12-13 сағат аралығында",
                        "Дүъшкү 12-13 шагда"
                    ), new Name(
                        "Хичээлдээ явна",
                        "Сабаққа кетемін",
                        "Кичээлге баар"
                    ), new Name(
                        "Өдрийн хоолоо иднэ",
                        "Түскі асымды ішемін",
                        "Дүъшкү чем чиир"
                    ),
                }, new List<Name> {
                    new Name(
                        "Өдрийн 16-18 цагт",
                        "Күндіз 16-18 сағат аралығында",
                        "Дүъшкү 16-18 шагда"
                    ), new Name(
                        "Хичээлээсээ ирнэ",
                        "Сабақтан келемін",
                        "Кичээлден кээр"
                    ), new Name(
                        "Гэрийн даалгавраа хийнэ",
                        "Үй тамсырмамды орындаймын",
                        "Онаалга кылыр"
                    ), new Name(
                        "Оройн хоолоо иднэ",
                        "Кешкі асымды ішемін",
                        "Кежээки чем чиир"
                    ),
                }, new List<Name> {
                    new Name(
                        "Шөнийн 20-22 цагт",
                        "Түнгі 20-22 сағат аралығында",
                        "Дүнеги 20-22 шагда"
                    ), new Name(
                        "Шөнийн 19-21 цагт",
                        "Түнгі 19-21 сағат аралығында",
                        "Дүнеги 19-21 шагда"
                    ), new Name(
                        "Шүдээ угаагаад унтана",
                        "Тісімді жуып жатамын",
                        "Дижин чуггаш, удуур"
                    ), new Name(
                        "Гэрийн ажилдаа тусална",
                        "Үй шаруасына көмектесемін",
                        "Өг ажылынга дузалаар"
                    ), new Name(
                        "Тоглоомоо хураана",
                        "Ойыншығымды жинаймын",
                        "Оюнну чыыр"
                    ), new Name(
                        "Маргаашийнхаа хичээлийн бэлтгэлээ хангана",
                        "Ертеңгі сабаққа дайындаламын",
                        "Эртенги кичээлдиң белеткелин кылыр"
                    ),
                }, new List<Name> {
                    new Name(
                        "Өглөө босно",
                        "Тәңертең тұрамын",
                        "Даңмылан турар"
                    ), new Name(
                        "Шүдээ угаана",
                        "Тісімді жуамын",
                        "Дижин чуур"
                    ), new Name(
                        "Өглөөний цайгаа ууна",
                        "Таңғы асымды ішемін",
                        "Даңмылангы шай ижер"
                    ), new Name(
                        "Дасгал хийнэ",
                        "Жаттығу жасаймын",
                        "Дасгал кылыр"
                    ), new Name(
                        "Дуртай тоглоомоороо тоглоно",
                        "Ұнататын ойынымды ойнаймын",
                        "Дуралыг оюннан ойнаар"
                    ), new Name(
                        "Гэрийн даалгавраа хийнэ",
                        "Үй тамсырмамды орындаймын",
                        "Онаалга кылыр"
                    ), new Name(
                        "Хичээлдээ явна",
                        "Сабаққа кетемін",
                        "Кичээлге баар"
                    ), new Name(
                        "Найзуудтайгаа тоглоно",
                        "Достарыммен ойнаймын",
                        "Адаштарынан ойнаар"
                    ), new Name(
                        "Өдрийн хоолоо иднэ",
                        "Түскі асымды ішемін",
                        "Дүъшкү чем чиир"
                    ), new Name(
                        "Зурагт үзнэ",
                        "Телевизор көремін",
                        "Зурагт көөр"
                    ), new Name(
                        "Оройн хоолоо иднэ",
                        "Кешкі асымды ішемін",
                        "Кежээки чем чиир"
                    ), new Name(
                        "Ороо засаад унтана",
                        "Төсегімді салып, жатамын",
                        "Дөжек кааш, удуур"
                    ),
                },
            })
        }, { GameTp.BBHBO2, new GameData(1, Name.HBO, false, default, 320, true, new Dictionary<string, float> {
                {"d1", 7.88f}, {"d2", 7.64f}, {"d3", 14.24f}, {"d_", 6.6f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Цахилгаан хэрэгслээс болгоомжлоорой",
                        "Электр құралдарынан абай болыңдар",
                        "Цахилгаан херекселден болгаангар"
                    ), new Name(
                        "Цахилгаанаар ажилладаг хэрэгслүүдийг олоорой.",
                        "Электрмен жұмыстайтын құралдарды тап.",
                        "Цахилгааннан ажылдаар херекселдерни тыпкар."
                    ), new Name(
                        "Зургийг сайтар ажиглаарай. Аль нь зөв үйлдэл вэ?",
                        "Суретке мұқият қара. Қайсы әрекет дұрыс?",
                        "Чурукту экитир көргер. Кайсы чөп чорук?"
                    ), new Name(
                        "Цахилгаан хэрэгсэлтэй ажиллахдаа болгоомжтой хандахыг зургаар анхааруулсан байна. Ажиглаад, ижлийг нь олоорой.",
                        "Токқа қосылатын құралдармен жұмыс істегенде абай болу керектігін суретте ескертіп көрсеткен. Мұқият қарап тиістісін тап.",
                        "Цахилгаан херекселден ажылдаарда, болгаанып турарын чурукта анхаарткан. Экитир көргеш, дөөйүн тыпкар."
                    ),
                },
            })
        }, { GameTp.BBHBO3, new GameData(1, Name.HBO, false, V3.Xy(540, 260), 310, true, new Dictionary<string, float> {
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Сургууль орчмын дуу чимээг судалцгаая",
                        "Мектеп айналасындағы дыбыстарды зерттейік",
                        "Сургуул кыдыының ыыт даажын судулаакай"
                    ), new Name(
                        "Дуу чимээг сонсоод, миний байгаа газрыг олоорой.",
                        "Дыбыстарды тыңдап, менің қайда екенімді тап.",
                        "Ыыт даашты дыңнааш, мээң турган черимни тыпкар."
                    ), new Name(
                        "Сургуулийн орчинд эрүүл мэндэд сайнаар болон муугаар нөлөөлдөг дуу чимээг сонсоод ялгаарай.",
                        "Мектеп ортасындағы денсаулыққа жақсы әсер ететін және зиянды дыбыстарды тыңдап, ажырат.",
                        "Сургуул кыдыында кадыкка экинен болгаш багайнан нөлөөлээр ыыт даашты дыңнааш, ылгагар."
                    ),
                }, new List<Name> {
                    new Name(
                        "Номын санд ном уншиж суухад саад болох дуу чимээ аль нь вэ?",
                        "Төмендегі дыбыстардың қайсысы кітапханада кітап оқуға кедергі келтіреді?",
                        "Ном саңынга ном номчуп олурарда, саад болур ыыт дааш кайсы?"
                    ), new Name(
                        "Чанга ярьж буй чимээ",
                        "Қатты сөйлеген дыбыс",
                        "Дыңзыг аайтып турар дааш"
                    ), new Name(
                        "Ном уншиж, тэмдэглэл хөтлөх чимээ",
                        "Кітап оқып, белгілеу жазған дыбыс",
                        "Ном номчуп, демдеглеп бижип турар дааш"
                    ),
                }, new List<Name> {
                    new Name(
                        "Сургуулийн хашаанаас гараад, ямар чимээг илүү анхаарч сонсох ёстой вэ?",
                        "Мектеп ауласынан шығып, қандай дыбыстарға көбірек көңіл бөлу керек?",
                        "Сургуулдуң кажаазынан үнгеш, кандыг даашты улуг кичээнгейлиг дыңнаар ужурлуг?"
                    ), new Name(
                        "Машины дохионы чанга чимээ",
                        "Көліктің сигналының қатты дыбысы",
                        "Машинниң дохиозунуң дыңзыг даажы"
                    ), new Name(
                        "Хүүхдүүдийн ярилцах чимээ",
                        "Балалардың сөйлескен дыбысы",
                        "Оолдарның домактажып турар даажы"
                    ),
                }, new List<Name> {
                    new Name(
                        "Биеийн тамирын хичээлд анхаарч сонсох чимээ аль нь вэ?",
                        "Дене шынықтыру сабағында қандай дыбысқа көңіл бөлу керек?",
                        "Күш дамыр кичээлинге кичээнгейлиг дыңнаар дааш кайсы?"
                    ), new Name(
                        "Багшийн шүглийн дуу",
                        "Мұғалімнің ысқырауығының дыбысы",
                        "Башкының шүгүлүнүң даажы"
                    ), new Name(
                        "Хүүхдүүдийн яриа",
                        "Балалардың сөйлегені",
                        "Оолдарның чугаазы"
                    ),
                }, new List<Name> {
                    new Name(
                        "Багш шинэ хичээл тайлбарлаж байхад аль чимээг анхаарах хэрэгтэй вэ?",
                        "Мұғалім жаңа сабақты түсіндіріп жатқанда қай дыбысқа назар аудару керек?",
                        "Башкы чаа кичээл тайылбырлап турарда, кай даашты кичээнгейге алыр херек?"
                    ), new Name(
                        "Багшийн яриаг",
                        "Мұғалімнің сөзі",
                        "Башкының чугаазын"
                    ), new Name(
                        "Найзынхаа яриаг",
                        "Досымның сөзі",
                        "Адажының чугаазын"
                    ),
                },
            })
        }, { GameTp.BBHBO4, new GameData(1, Name.HBO, false, V3.Xy(540, 260), 310, true, new Dictionary<string, float> {
                {"d1", 9.08f}, {"d2", 8.68f}, {"d3", 10f}, {"d_", 8.08f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Тэжээвэр амьтдын ашиг шим",
                        "Үй жануарларының пайдасы",
                        "Азырал амытаннарның ажык шимизи"
                    ), new Name(
                        "Амьтдыг тохирох орчинд нь зөв байрлуулаарай.",
                        "Жануарларды тиісті ортасына дұрыс орналастыр.",
                        "Амытаннарны таарыыр черинге чиге орнуктургар."
                    ), new Name(
                        "Тэжээвэр амьтдын ашиг шим юу вэ? Зөв харгалзуулан холбоорой.",
                        "Үй жануарларының қандай пайдасы бар? Дұрыс сәйкестір.",
                        "Азырал амытаннарның ажык шими деп чүү? Чөп холбагар."
                    ), new Name(
                        "Энэ амьтныг тэжээхэд хэрэгтэй зүйлсийг сонгоорой.",
                        "Бұл жануарды асырау үшін қажетті заттарды таңда.",
                        "Бо амытанны азыраарда, херектиг чүүлдерни соңгугар."
                    ),
                }, new List<Name> {
                    new Name(
                        "Зөгий",
                        "Ара",
                        "Ар"
                    ), new Name(
                        "Зөгийн бал",
                        "Араның балы",
                        "Арның балы"
                    ), new Name(
                        "Үнээ",
                        "Сиыр",
                        "Инек"
                    ), new Name(
                        "Сүү",
                        "Сүт",
                        "Сүт"
                    ), new Name(
                        "Ямаа",
                        "Ешкі",
                        "Өшкү"
                    ), new Name(
                        "Ноолуур",
                        "Түбіт",
                        "Өшкүнүң тивиди"
                    ), new Name(
                        "Тэмээ",
                        "Түйе",
                        "Теве"
                    ), new Name(
                        "Тэмээний ноос",
                        "Түйенің жүні",
                        "Тевениң дүгү"
                    ), new Name(
                        "Гүү",
                        "Бие",
                        "Бе"
                    ), new Name(
                        "Айраг",
                        "Қымыз",
                        "Айраг"
                    ), new Name(
                        "Хонь",
                        "Қой",
                        "Хой"
                    ), new Name(
                        "Хонины ноос",
                        "Қойдың жүні",
                        "Хой дүгү"
                    ), new Name(
                        "Тахиа",
                        "Тауық",
                        "Дагаа"
                    ), new Name(
                        "Өндөг",
                        "Жұмыртқа",
                        "Чумурга"
                    ), new Name(
                        "Гахай",
                        "Доңыз",
                        "Кагай"
                    ), new Name(
                        "Гахайн мах",
                        "Доңыздың еті",
                        "Кагайның эъди"
                    ), new Name(
                        "Загас",
                        "Балық",
                        "Балык"
                    ), new Name(
                        "Загасны мах",
                        "Балық еті",
                        "Балыктың эъди"
                    ),
                },
            })
        }, { GameTp.BBHBO5, new GameData(1, Name.HBO, false, default, 310, true, new Dictionary<string, float> {
                {"d1", 11.96f}, {"d2_1", 11.44f}, {"d2_2", 11.52f}, {"d3_1", 7.96f}, {"d3_2", 8.56f}, {"d3_3", 10.52f}, {"d3_4", 8.52f}, {"d3_5", 11.44f}, {"d3_6", 9.36f}, {"d3_7", 13.12f}, {"d_", 6.08f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Өдөр, шөнийн ялгаа",
                        "Күн мен түннің айырмашылығы",
                        "Хүндүс, дүнениң ылгалы"
                    ), new Name(
                        "Нарны байрлалыг сайтар ажиглаад, зургуудыг зөв дараалалд оруулаарай.",
                        "Күннің орналасуын мұқият қарап, суреттерді дұрыс ретке келтір.",
                        "Күннүң туружун экитир көргеш, чуруктарны чөп дараалалга кииргер."
                    ), new Name(
                        "Үйл явдлууд хэзээ болдгийг тохируулан байрлуулаарай.",
                        "Оқиғаларды олардың қашан болатынына қарай орналастыр.",
                        "Болуушкуннар кажан болурун таартып орнуктургар."
                    ), new Name(
                        "Дараах үйлүүдийг өдөр, шөнийн алинд нь хийж болох вэ?",
                        "Төмендегі әрекеттерді күндіз бен түннің қайсысында жасауға болады?",
                        "Дарыйгы кылдыныгларны хүндүс, дүнениң кайсында кылып болур?"
                    ), new Name(
                        "Өглөө ба өдөр",
                        "Тәңертең және күндіз",
                        "Даңмылан болгаш дүъш"
                    ), new Name(
                        "Үдэш ба орой",
                        "Кеш және кешқұрым",
                        "Дүъш болгаш кежээ"
                    ),
                }, new List<Name> {
                    new Name(
                        "Ажил, сургуульдаа явах",
                        "Жұмысқа, мектепке кету",
                        "Ажыл, сургуулга баар"
                    ), new Name(
                        "Номын санд сууж ном унших",
                        "Кітапханада отырып кітап оқу",
                        "Ном саңынга олуруп, ном номчуур"
                    ), new Name(
                        "Хонь, мал бэлчих",
                        "Қой, мал жайылу",
                        "Хой, мал оъттаар"
                    ),
                }, new List<Name> {
                    new Name(
                        "Ажлаасаа ирээд амрах",
                        "Жұмыстан келіп, демалу",
                        "Ажылдан келгеш, амыраар"
                    ), new Name(
                        "Үлгэр яриа сонсох",
                        "Ертегі тыңдау",
                        "Тоол дыңнаар"
                    ), new Name(
                        "Хонь, мал хотлох",
                        "Қой, мал қоралау",
                        "Хой, мал кежээлээр"
                    ),
                }, new List<Name> {
                    new Name(
                        "Хичээлдээ явах",
                        "Сабаққа бару",
                        "Кичээлге баар"
                    ), new Name(
                        "Тоглох",
                        "Ойнау",
                        "Ойнаар"
                    ), new Name(
                        "Гэрийн ажилд туслах",
                        "Үй жұмысына көмектесу",
                        "Өг ажылынга дузалаар"
                    ), new Name(
                        "Үнээ малаа саах, хариулах",
                        "Мал сауу, жайю",
                        "Инек малды саар, кадарар"
                    ),
                }, new List<Name> {
                    new Name(
                        "Унтах",
                        "Ұйықтау",
                        "Удуур"
                    ), new Name(
                        "Зүүдлэх",
                        "Түс көру",
                        "Дүжээр"
                    ), new Name(
                        "Галын наадам хийх",
                        "Алау жағу рәсімін жасау",
                        "От наадымы кылыр"
                    ), new Name(
                        "Салют буудуулах",
                        "Салюут ату",
                        "Салют адар"
                    ),
                }, new List<Name> {
                    new Name(
                        "Аль нь гэрэл, дулаан ялгаруулдаг вэ?",
                        "Қайсысы өзінен жарық пен жылу бөледі?",
                        "Кайсы херел, чылыгны үндүрер?"
                    ), new Name(
                        "Нар",
                        "Күн",
                        "Күн"
                    ), new Name(
                        "Сар",
                        "Ай",
                        "Ай"
                    ), new Name(
                        "Од",
                        "Жұлдыз",
                        "Сылдыс"
                    ),
                }, new List<Name> {
                    new Name(
                        "Нар аль зүгээс манддаг вэ?",
                        "Күн қай жақтан шығады?",
                        "Күн кай чүктен үнер?"
                    ), new Name(
                        "Зүүн",
                        "Сол жақ",
                        "Чүүн"
                    ), new Name(
                        "Баруун",
                        "Оң жақ",
                        "Барыын"
                    ), new Name(
                        "Урд",
                        "Шығыс",
                        "Мурнуу"
                    ),
                }, new List<Name> {
                    new Name(
                        "Шөнө яагаад харанхуй, хүйтэн болдог вэ?",
                        "Неліктен түнде қараңғы және суық болады?",
                        "Дүне чүге хараңгы, соок турар?"
                    ), new Name(
                        "Сар нь дулаан ялгаруулдаггүй учраас хүйтэн байдаг",
                        "Айдан жылу бөлінбейтіндіктен суық болады",
                        "Ай чылыг үндүрбес болгаш соок турар"
                    ), new Name(
                        "Нартай болохоор",
                        "Күн шығып тұрғандықтан",
                        "Күннүг болгаш"
                    ),
                }, new List<Name> {
                    new Name(
                        "Нарны гэрэл ямар үед хамгийн их байдаг вэ?",
                        "Күн сәулесі қай уақытта көбірек түседі?",
                        "Күннүң херели кай үеде эң улуг дээр?"
                    ), new Name(
                        "Өдөр",
                        "Күндіз",
                        "Хүндүс"
                    ), new Name(
                        "Өглөө",
                        "Тәңертең",
                        "Даңмылан"
                    ), new Name(
                        "Орой",
                        "Кешке",
                        "Кежээ"
                    ),
                }, new List<Name> {
                    new Name(
                        "Дэлхий нарыг тойрон эргэж байх үед сүүдэр талд хоногийн аль хэсэг болдог вэ?",
                        "Жер күнді айналса, тәуліктің қай бөлігі көлеңке жағында болады?",
                        "Делегей күннү дескинип турар үеде, көлеңги ийинде хонуктуң кай кезээ боп турар?"
                    ), new Name(
                        "Шөнө",
                        "Түн",
                        "Дүне"
                    ), new Name(
                        "Өглөө",
                        "Тәңертең",
                        "Даңмылан"
                    ), new Name(
                        "Өдөр",
                        "Күндіз",
                        "Хүндүс"
                    ),
                }, new List<Name> {
                    new Name(
                        "Нар туссан газаp __________ байдаг.",
                        "Күн түскен жер __________ болады.",
                        "Күн дээн черде __________ турар."
                    ), new Name(
                        "Дулаан",
                        "Жылы",
                        "Чылыг"
                    ), new Name(
                        "Сэрүүн",
                        "Салқын",
                        "Сериин"
                    ), new Name(
                        "Хүйтэн",
                        "Суық",
                        "Соок"
                    ),
                }, new List<Name> {
                    new Name(
                        "Нар тусаагүй, сүүдэр газар __________ байдаг.",
                        "Күн түспеген, көлеңке жер, __________ болады.",
                        "Күн дегбээн, көлеңги чер __________ турар."
                    ), new Name(
                        "Сэрүүн",
                        "Салқын",
                        "Сериин"
                    ), new Name(
                        "Дулаан",
                        "Жылы",
                        "Чылыг"
                    ), new Name(
                        "Гэрэлтэй",
                        "Жарық",
                        "Херелдиг"
                    ),
                },
            })
        }, { GameTp.BBHBO6, new GameData(2, Name.HBO, true, V3.Xy(540, 260), 310, true, new Dictionary<string, float> {
                {"d1", 8.76f}, {"d2_1", 7.44f}, {"d2_2", 7.32f}, {"d2_3", 7.16f}, {"d2_4", 9.4f}, {"d2_5", 8.24f}, {"d2_6", 7.84f}, {"d3_1", 8.44f}, {"d3_1b", 5.24f}, {"d3_1z", 7.64f}, {"d3_2", 10.76f}, {"d3_2b", 5.4f}, {"d3_2z", 5.36f}, {"d3_3", 8.44f}, {"d3_3b", 5.52f}, {"d3_3z", 8.92f}, {"d_", 6.2f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Миний бие",
                        "Менің денем",
                        "Мээң мага-бодум"
                    ), new Name(
                        "Биеийнхээ нүдэнд харагдах хэсгүүдийг зөв заагаарай.",
                        "Денеңнің көзөге  көрінетін бөліктерін көрсет.",
                        "Мага-бодугарның каракка көстүүр кезектерин чиге аайткар."
                    ), new Name(
                        "Аль нь биеэ хамгаалах зөв үйлдэл вэ?",
                        "Қайсысы өзін-өзі қорғаудың дұрыс әрекетін жасап жатыр?",
                        "Кайсы бодун хамгаалаар чөп кылдыныг кылып тур?"
                    ), new Name(
                        "Зөв сууж хичээлээ хийж байгаа охин аль нь вэ?",
                        "Қайсысы өзін-өзі қорғаудың дұрыс әрекетін жасап жатыр?",
                        "Кайсы бодун хамгаалаар чөп кылдыныг кылып тур?"
                    ), new Name(
                        "Аль нь биеэ хамгаалах зөв үйлдэл вэ?",
                        "Қайсысы өзін-өзі қорғаудың дұрыс әрекетін жасап жатыр?",
                        "Кайсы бодун хамгаалаар чөп кылдыныг кылып тур?"
                    ),
                }, new List<Name> {
                    new Name(
                        "Толгой",
                        "Бас",
                        "Баш"
                    ), new Name(
                        "Хүзүү",
                        "Мойын",
                        "Моюн"
                    ), new Name(
                        "Мөр",
                        "Иық",
                        "Эгин"
                    ), new Name(
                        "Тохой",
                        "Шынтақ",
                        "Шенек"
                    ), new Name(
                        "Гар",
                        "Қол",
                        "Хол"
                    ), new Name(
                        "Өвдөг",
                        "Тізе",
                        "Дискек"
                    ), new Name(
                        "Хөл",
                        "Аяқ",
                        "Бут"
                    ), new Name(
                        "Гэдэс",
                        "Іш",
                        "Ижин"
                    ),
                }, new List<Name> {
                    new Name(
                        "Харах үүрэгтэй эрхтнийг олж дараарай.",
                        "Көру міндетін атқаратын мүшені тауып бас.",
                        "Көөр үүргелиг эрхтэнни тыпкаш, баскар."
                    ), new Name(
                        "Сонсох үүрэгтэй эрхтнийг олж дараарай.",
                        "Есту міндетін атқаратын мүшені тауып бас.",
                        "Дыңнаар үүргелиг эрхтэнни тыпкаш, баскар."
                    ), new Name(
                        "Үнэрлэх үүрэгтэй эрхтнийг олж дараарай.",
                        "Иіс сезу міндетін атқаратын мүшені тауып бас.",
                        "Чыдырхаар үүргелиг эрхтэнни тыпкаш, баскар."
                    ), new Name(
                        "Ярих, амтлах үүрэгтэй эрхтнийг олж дараарай.",
                        "Сөйлеу мен дәм сезу міндетін атқаратын мүшені тауып бас.",
                        "Домактаныыр, амсаар үүргелиг эрхтэнни тыпкаш, баскар."
                    ), new Name(
                        "Атгах, барих, мэдрэх үүрэгтэй эрхтнийг олж дараарай.",
                        "Қысу, ұстау және сезіну міндетін атқаратын мүшені тауып бас.",
                        "Адыштаар, тудар, медерээр үүргелиг эрхтэннерни тыпкаш, баскар."
                    ), new Name(
                        "Алхах, гишгэх, тулах үүрэгтэй эрхтнийг олж дараарай.",
                        "Жүру, қадам басу, міндетін атқаратын мүшені тауып бас.",
                        "Кылаштаар, базар, тулар үүргелиг эрхтэнни тыпкаш, баскар."
                    ),
                }
            })
        }, { GameTp.BBHBO7, new GameData(2, Name.HBO, true, default, 500, true, new Dictionary<string, float> {
                {"d1", 10.92f}, {"dBarilga", 7.2f}, {"dHaranhui", 10.08f}, {"dHome", 8.6f}, {"dHoriglono", 7.6f}, {"dMuhar", 6.68f}, {"dNuh", 10f}, {"dZam", 7.8f}, {"d_", 11.72f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Сургуулиас гэр хүрэх замд хэрхэн аюулгүй зорчих вэ?",
                        "Мектептен үйге дейінгі жолода қалай қауіпсіз жүруге болады?",
                        "Сургуулдан өгге баар орукка канчап айыыл чок чоруур?"
                    ), new Name(
                        "Аюулгүй замаар гэртээ харихад нь Жижгээд туслаарай.",
                        "Жижгээнің қауіпсіз жолмен үйіне қайтуына көмектес.",
                        "Айыыл чок оруктан өөнге баарынга Жижгээге дузалагар."
                    ), new Name(
                        "СУРГУУЛЬ",
                        "Мектеп",
                        "Сургуул"
                    ), new Name(
                        "ГЭР",
                        "Үй",
                        "Өг"
                    ), new Name(
                        "ДЭЛГҮҮР",
                        "Дүкен",
                        "Садыг"
                    ), new Name(
                        "ЧИХЭР",
                        "Тәтті",
                        "Чигир"
                    ), new Name(
                        "ЗАЙРМАГ",
                        "Балмұздақ",
                        "Зайрмаг"
                    ), new Name(
                        "ГАР ЧИЙДЭН",
                        "Қол шам",
                        "Хол чиидэн"
                    ),
                },
            })
        }, { GameTp.BBHBO8, new GameData(2, Name.HBO, false, V3.Xy(540, 260), 320, true, new Dictionary<string, float> {
                {"d1", 8.08f}, {"d2", 9.48f}, {"d3", 12.4f}, {"d3_1", 26.84f}, {"d3_2", 22.52f}, {"d3_3", 23.48f}, {"d3_4", 23.04f}, {"d_", 7.96f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Ургамалд яагаад арчилгаа хэрэгтэй вэ?",
                        "Неліктен өсімдіктер күтімді қажет етеді?",
                        "Үнүшке арчылгаа чүге херектиг?"
                    ), new Name(
                        "Ургамлуудыг нэртэй нь зөв холбоорой.",
                        "Өсімдіктерді атауларымен дұрыс сәйкестір.",
                        "Үнүштерни аттарынга чиге холбагар."
                    ), new Name(
                        "Зургийг ажиглаад цэцгүүдийг зөв ангилаарай.",
                        "Суретке қарап, гүлдерді дұрыс топта.",
                        "Чурукту экитир көргеш, чечектерни чиге ылгагар."
                    ), new Name(
                        "Цэцэгсийг дарааллын дагуу зөв арчилж ургуулаарай.",
                        "Гүлдерді дұрыс ретіпен баптап, өсір.",
                        "Чечектерни дараалал аайынан чиге арчылап, өскүргер."
                    ),
                }, new List<Name> {
                    new Name(
                        "Зуун наст",
                        "Жүзжылдық (Алоэ)",
                        "Зуун наст"
                    ), new Name(
                        "Алаг халгай",
                        "Ала қалақай",
                        "Шоокар шагар оът"
                    ), new Name(
                        "Нөмөргөнө",
                        "Әйелбақыты",
                        "Нөмөргөнө"
                    ), new Name(
                        "Шимтэглээ",
                        "Қазтамақ",
                        "Шимтэглэй"
                    ), new Name(
                        "Судалт од",
                        "Дұғагүлі",
                        "Судалдыг сылдыс"
                    ), new Name(
                        "Алаг цэцэг",
                        "Ала гүл",
                        "Шоокар чечек"
                    ), new Name(
                        "Мөнхрөө",
                        "Үй қоянқұлағы",
                        "Мөнхрөө"
                    ), new Name(
                        "Зузаахай",
                        "Қалыңқой",
                        "Зузаахай"
                    ),
                }, new List<Name> {
                    new Name(
                        "Гоёмсог навчтай ургамал",
                        "Әсем жапырақты өсімдік",
                        "Чараш калбылыг үнүш"
                    ), new Name(
                        "Мөнхрөө",
                        "Үй қоянқұлағы",
                        "Мөнхрөө"
                    ), new Name(
                        "Удам бор",
                        "Фикус гүлі",
                        "Удам бора"
                    ), new Name(
                        "Алаг халгай",
                        "Ала қалақай",
                        "Шоокар шагар оът"
                    ), new Name(
                        "Гундаахай",
                        "Шаянот (Диффенбахия)",
                        "Гундаахай"
                    ),
                }, new List<Name> {
                    new Name(
                        "Гоёмсог цэцэглэдэг ургамал",
                        "Әдемі гүлдейтін өсімдік",
                        "Чараш чечеклээр үнүш"
                    ), new Name(
                        "Гоо даль",
                        "Әсем фуксия",
                        "Гоо даль"
                    ), new Name(
                        "Алаг цэцэг",
                        "Ала гүл",
                        "Шоокар чечек"
                    ), new Name(
                        "Шимтэглэй",
                        "Қазтамақ",
                        "Шимтэглэй"
                    ), new Name(
                        "Нил цэцэг",
                        "Шегіргүл",
                        "Нил чечек"
                    ),
                }, new List<Name> {
                    new Name(
                        "Шүүслэг навчтай ургамал",
                        "Жапырағы шырынды өсімдік",
                        "Шүүсүннүг калбылыг үнүш"
                    ), new Name(
                        "Зуун наст",
                        "Жүзжылдық (Алоэ)",
                        "Зуун наст"
                    ), new Name(
                        "Арш",
                        "Кактус",
                        "Кактус"
                    ),
                }, new List<Name> {
                    new Name(
                        "Унжиж ургадаг, ороонго ургамал",
                        "Салбырып өсетін, оралтылған өсімдік",
                        "Халаңнап өзер, ороонго үнүш"
                    ), new Name(
                        "Авиргана",
                        "Шырмауық",
                        "Авиргана"
                    ), new Name(
                        "Багцхан",
                        "Хлорофитум гүлі",
                        "Багцхан"
                    ),
                }, new List<Name> {
                    new Name(
                        "Алаг халгай",
                        "Ала қалақай",
                        "Шоокар шагар оът"
                    ), new Name(
                        "Нил цэцэг",
                        "Шегіргүл",
                        "Нил чечек"
                    ), new Name(
                        "Авиргана",
                        "Шырмауық",
                        "Авиргана"
                    ), new Name(
                        "Зуун наст",
                        "Жүзжылдық (Алоэ)",
                        "Зуун наст"
                    ),
                },
            })
        }, { GameTp.BBHBO9, new GameData(2, Name.HBO, false, V3.Xy(540, 260), 310, true, new Dictionary<string, float> {
                {"d1", 9.56f}, {"d2", 9.24f}, {"d3", 10f}, {"d3_1b", 3.92f}, {"d3_1z", 5.32f}, {"d3_2b", 4.56f}, {"d3_2z", 5.36f}, {"d3_3b", 6.36f}, {"d3_3z", 7.2f}, {"d3_4b", 5.28f}, {"d3_4z", 6.08f}, {"d_", 6.2f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Уул усаа хайрлая",
                        "Табиғатты аялайық",
                        "Чуртувусту хайрлаакай"
                    ), new Name(
                        "Таних тэмдгийг зөв харгалзуулаарай.",
                        "Белгілерді дұрыс сәйкестір.",
                        "Таныыр демдекти чиге холбагар."
                    ), new Name(
                        "Зурагт тохирох нэрийг зөөж байрлуулаарай.",
                        "Суретке сәйкес атауды тасмалдап орналастыр.",
                        "Чурукка таарыыр атты дажып орнуктургар."
                    ), new Name(
                        "Аль нь уул, усыг хамгаалж буй зөв үйлдэл вэ?",
                        "Қайсысы табиғатты қорғаған дұрыс әрекет?",
                        "Кайсы чуртун хамгаалап турар чиге чорук?"
                    ),
                }, new List<Name> {
                    new Name(
                        "Нуур",
                        "Көл",
                        "Хөл"
                    ), new Name(
                        "Гол",
                        "Өзен",
                        "Хем"
                    ), new Name(
                        "Тал",
                        "Кең дала",
                        "Ажык чер"
                    ), new Name(
                        "Уул",
                        "Тау",
                        "Даг"
                    ),
                }, new List<Name> {
                    new Name(
                        "Мод тарих",
                        "Ағаш егу",
                        "Ыяш тарыыр"
                    ), new Name(
                        "Мод тайрах",
                        "Ағаш кесу",
                        "Ыяш кезер "
                    ), new Name(
                        "Голын хог цэвэрлэх",
                        "Өзеннің қоқысын тазалау",
                        "Хемниң хогун шеверлээр"
                    ), new Name(
                        "Голд хог хаях",
                        "Өзенге қоқ тастау",
                        "Хемге хок каар"
                    ), new Name(
                        "Цэцэг ногоо услах",
                        "Өсімдіктерді сурау",
                        "Чечек ногааны суггарар"
                    ), new Name(
                        "Цэцэг ногоог үндсээр нь тасдах",
                        "Өсімдіктерді тамырымен жұлу",
                        "Чечек ногааны үндесининен сыгар"
                    ), new Name(
                        "Нөхөн сэргээлт хийх",
                        "Жерді қалпына келтіру",
                        "Чазап сергедиир"
                    ), new Name(
                        "Уул, газар ухах",
                        "Тау, жер қопару",
                        "Даг, черни чарар"
                    ),
                },
            })
        }, { GameTp.BBHBO10, new GameData(2, Name.HBO, true, V3.Xy(540, 260), 310, true, new Dictionary<string, float> {
                {"d1", 8.44f}, {"d2_1", 10.16f}, {"d2_2", 9.36f}, {"d2_3", 9.8f}, {"d3_1", 10.84f}, {"d3_2", 10.32f}, {"d3_3", 11.6f}, {"d_", 7.32f},
            }, new List<List<Name>> {
                new List<Name> {
                    new Name(
                        "Цаг агаарт тохируулан хувцаслая",
                        "Ауа-райына сәйкес киінейік",
                        "Шаг агаарга таарты хевениикей"
                    ), new Name(
                        "Зургийг ажиглаад тохирох үгтэй нь холбоорой.",
                        "Суретке қарап, тиісті сөздермен сәйкестір.",
                        "Чурукту экитир көргеш, таарыыр сөзүнге холбагар."
                    ),
                }, new List<Name> {
                    new Name(
                        "Нартай",
                        "Ашық",
                        "Күннүг"
                    ), new Name(
                        "Бороотой",
                        "Жаңбырлы",
                        "Үскенниг"
                    ), new Name(
                        "Цастай",
                        "Қарлы",
                        "Харлыг"
                    ), new Name(
                        "Салхитай",
                        "Желді",
                        "Салгынныг"
                    ), new Name(
                        "Аянгатай",
                        "Найзағайлы",
                        "Аянгалыг"
                    ),
                }, new List<Name> {
                    new Name(
                        "Томоо нартай, халуун өдөр ямар хувцас өмсөх вэ?",
                        "Томоо ыстық күні қандай киім киеді?",
                        "Томоо күннүг, изиг хүн кандыг хеп кедер?"
                    ), new Name(
                        "Томоо бороотой, сэрүүн өдөр ямар хувцас өмсөх вэ?",
                        "Томоо жаңбырлы, салқын күні қандай киім киеді?",
                        "Томоо үскенниг, сериин хүн кандыг хеп кедер?"
                    ), new Name(
                        "Томоо цастай, хүйтэн өдөр ямар хувцас өмсөх вэ?",
                        "Томоо қарлы, суық күні қандай киім киеді?",
                        "Томоо харлыг, соок хүн кандыг хеп кедер?"
                    ),
                }, new List<Name> {
                    new Name(
                        "Хэдэн өдөр нь нартай байна вэ?",
                        "Неше күн ашық болады екен?",
                        "Каш хүн күннүг тур?"
                    ), new Name(
                        "Хэдэн өдөр нь сэрүүн байна вэ?",
                        "Неше күн салқын болады екен?",
                        "Каш хүн сериин тур?"
                    ), new Name(
                        "Аялалд явахад аль өдөр тааламжтай байна вэ?",
                        "Серуенге шығу үшін қай күн қолайлы екен?",
                        "Аян чорукка чоруурда, кай хүн тааржыыр иргин?"
                    ),
                },
            })
        },
    };
}
public class MyBido {
    Image mouth, eye, iris, handL, handR;
    Sprite[] mouths, eyes, hands;
    IEnumerator cor;
    List<IEnumerator> cors = new List<IEnumerator>();
    static Vector3 posL = V3.Xy(-20, -320), posR = V3.Xy(20, -320);
    AudioSource src;
    Song correctSong, wrongSong, winSong, canSong, goodSong;
    bool isShow => !Song.data.bidoPos.IsDef();
    public MyBido() {
        GameObject go = General._.go.ChildNameGo("Bido");
        src = go.Gc<AudioSource>();
        correctSong = new Song("General/Bido/", "Correct");
        wrongSong = new Song("General/Bido/", "Wrong");
        winSong = new Song("General/Bido/", "Win");
        canSong = new Song("General/Bido/", "Can");
        goodSong = new Song("General/Bido/", "Good");
        if (isShow) {
            go.Tlp(Song.data.bidoPos);
            mouths = Resources.LoadAll<Sprite>("General/Bido/mouth");
            eyes = Resources.LoadAll<Sprite>("General/Bido/eye");
            hands = Resources.LoadAll<Sprite>("General/Bido/hand");
            mouth = go.Child(0).Img();
            eye = go.Child(1, 0).Img();
            iris = go.Child(1, 0, 0).Img();
            handL = go.Child(2).Img();
            handR = go.Child(3).Img();
        } else {
            for (int i = 0; i < go.Tcc(); i++)
                go.ChildHide(i);
        }
        Idle();
    }
    public void Idle() { StaCor(IdleCor()); }
    public void Correct(bool isCorrect) {
        if (isCorrect) StaCor(CorrectCor());
        else StaCor(WrongCor());
    }
    public void Win() { StaCor(WinCor()); }
    public void Good() {
        if (Rnd.B) StaCor(CanCor());
        else StaCor(GoodCor());
    }
    public void VolSpd(float vol, float spd) {
        src.volume = vol;
        src.pitch = spd;
    }
    void StaCor(IEnumerator c) {
        if (cor.NotNull()) {
            General._.StopCor(cor);
            cors.ForEach(cor => General._.StopCor(cor));
        }
        General._.StaCor(cor = c);
    }
    void Init(Song song) {
        if (isShow) {
            mouth.sprite = mouths[0];
            eye.sprite = eyes[1];
            handL.sprite = hands[0];
            handR.sprite = hands[1];
            handL.Tlp(posL);
            handR.Tlp(posR);
            handL.Tlr(Q.O);
            handR.Tlr(Q.O);
        }
        if (song.NotNull()) {
            src.clip = song.clip;
            src.Play();
        } else src.Stop();
    }
    IEnumerator IdleCor() {
        Init(null);
        while (isShow) {
            yield return EyeCor(5, 10, 84, 90);
            yield return Frm(256);
        }
    }
    IEnumerator WrongCor() {
        Init(wrongSong);
        Sign("Wrong");
        if (isShow) {
            cors = Mb.Lis(EyeCor(24, 30),
                MouthCor((10, 12), (12, 9), (14, 12), (20, 0), (22, 9), (25, 0)),
                HandCor((5, 3, 3), (9, 2, 0), (24, 3, 3), (30, 0, 0)),
                HandPosCor(false, (13, -100, -280), (22, -100, -280), (30, posL.x, posL.y)),
                HandPosCor(true, (13, 80, posR.y), (22, 80, posR.y), (30, posR.x, posR.y)),
                HandRotCor(false, (13, 110), (22, 110), (27, 0)));
            cors.ForEach(cor => General._.StaCor(cor));
        }
        yield return Frm(33);
        Idle();
    }
    IEnumerator CorrectCor() {
        Init(correctSong);
        Sign("Correct");
        if (isShow) {
            cors = Mb.Lis(EyeCor(20, 27),
                MouthCor((2, 12), (10, 9), (22, 0)),
                HandCor((10, 1, 1), (30, 0, 0)),
                HandPosCor(false, (10, -80, posL.y), (22, -80, posL.y), (27, posL.x, posL.y)),
                HandPosCor(true, (10, 80, posR.y), (22, 80, posR.y), (27, posR.x, posR.y)));
            cors.ForEach(cor => General._.StaCor(cor));
        }
        yield return Frm(28);
        Idle();
    }
    IEnumerator CanCor() {
        Init(canSong);
        Sign("Can");
        if (isShow) {
            cors = Mb.Lis(EyeCor(32, 38),
                MouthCor((12, 9), (19, 12), (20, 9), (28, 7), (29, 9), (33, 0), (34, 11), (35, 12), (38, 7), (40, 0)),
                HandCor((10, 0, 5), (40, 0, 0)),
                HandPosCor(false, (10, -80, posL.y), (35, -80, posL.y), (40, posL.x, posL.y)),
                HandPosCor(true, (10, 80, posR.y), (35, 80, posR.y), (40, posR.x, posR.y)),
                HandSclCor(true, (10, 1), (15, 1.3f), (30, 1.3f), (35, 1)));
            cors.ForEach(cor => General._.StaCor(cor));
        }
        yield return Frm(51);
        Idle();
    }
    IEnumerator GoodCor() {
        Init(goodSong);
        Sign("Good");
        if (isShow) {
            int l = 15, dt = 5;
            List<(int, float, float)> lisL = Mb.Lis((10, posL.x, posL.y)), lisR = Mb.Lis((10, posR.x, posR.y));
            for (int i = 0; i < 4; i += 2) {
                lisL.Add((20 + i * dt, posL.x - l, posL.y + l), (20 + (i + 1) * dt, posL.x, posL.y));
                lisR.Add((20 + i * dt, posR.x + l, posR.y - l), (20 + (i + 1) * dt, posR.x, posR.y));
            }
            cors = Mb.Lis(EyeCor(32, 38),
                MouthCor((12, 9), (17, 12), (18, 9), (33, 0)),
                HandCor((10, 4, 4), (40, 0, 0)),
                HandPosCor(false, lisL.Arr()),
                HandPosCor(true, lisR.Arr()));
            cors.ForEach(cor => General._.StaCor(cor));
        }
        yield return Frm(40);
        Idle();
    }
    IEnumerator WinCor() {
        Init(winSong);
        Sign("Win");
        if (isShow) {
            int l = 15, dt = 5;
            List<(int, float, float)> lisL = Mb.Lis((10, posL.x, posL.y)), lisR = Mb.Lis((10, posR.x, posR.y));
            for (int i = 0; i < 10; i += 2) {
                lisL.Add((20 + i * dt, posL.x - l, posL.y + l), (20 + (i + 1) * dt, posL.x, posL.y));
                lisR.Add((20 + i * dt, posR.x + l, posR.y - l), (20 + (i + 1) * dt, posR.x, posR.y));
            }
            cors = Mb.Lis(EyeCor(32, 38),
                MouthCor((3, 9), (5, 7), (8, 12), (12, 9), (15, 10), (19, 9), (20, 0), (38, 7), (42, 9), (48, 7), (52, 12), (55, 7), (58, 9), (65, 7), (67, 0)),
                HandCor((10, 4, 4), (79, 0, 0)),
                HandPosCor(false, lisL.Arr()),
                HandPosCor(true, lisR.Arr()));
            cors.ForEach(cor => General._.StaCor(cor));
        }
        yield return Frm(79);
        Idle();
    }
    IEnumerator HandCor(params (int, int, int)[] a) {
        handL.sprite = hands[0];
        handR.sprite = hands[1];
        for (int i = 0; i < a.Length; i++) {
            yield return Frm(i == 0 ? a[i].Item1 : a[i].Item1 - a[i - 1].Item1);
            handL.sprite = hands[a[i].Item2 * 2];
            handR.sprite = hands[a[i].Item3 * 2 + 1];
        }
    }
    IEnumerator HandPosCor(bool isR, params (int, float, float)[] a) {
        var hand = isR ? handR : handL;
        for (int i = 0; i < a.Length; i++) {
            Vector3 p1 = i == 0 ? isR ? posR : posL : V3.Xy(a[i - 1].Item2, a[i - 1].Item3),
                p2 = V3.Xy(a[i].Item2, a[i].Item3);
            yield return General._.Cor(t => hand.Tlp(V3.Lerp(p1, p2, t)), (i == 0 ? a[i].Item1 : a[i].Item1 - a[i - 1].Item1) / 30f);
        }
    }
    IEnumerator HandRotCor(bool isR, params (int, float)[] a) {
        var hand = isR ? handR : handL;
        for (int i = 0; i < a.Length; i++) {
            Quaternion p1 = i == 0 ? Q.O : Q.Z(a[i - 1].Item2), p2 = Q.Z(a[i].Item2);
            yield return General._.Cor(t => hand.Tlr(Q.Lerp(p1, p2, t)), (i == 0 ? a[i].Item1 : a[i].Item1 - a[i - 1].Item1) / 30f);
        }
    }
    IEnumerator HandSclCor(bool isR, params (int, float)[] a) {
        var hand = isR ? handR : handL;
        for (int i = 0; i < a.Length; i++) {
            Vector3 p1 = i == 0 ? V3.I : V3.V(a[i - 1].Item2), p2 = V3.V(a[i].Item2);
            yield return General._.Cor(t => hand.Tls(V3.Lerp(p1, p2, t)), (i == 0 ? a[i].Item1 : a[i].Item1 - a[i - 1].Item1) / 30f);
        }
    }
    IEnumerator MouthCor(params (int, int)[] a) {
        mouth.sprite = mouths[0];
        for (int i = 0; i < a.Length; i++) {
            yield return Frm(i == 0 ? a[i].Item1 : a[i].Item1 - a[i - 1].Item1);
            mouth.sprite = mouths[a[i].Item2];
        }
    }
    IEnumerator EyeCor(params int[] a) {
        eye.sprite = eyes[1];
        iris.Show();
        for (int i = 0; i < a.Length; i += 2) {
            yield return Frm(i == 0 ? a[i] : a[i] - a[i - 1]);
            eye.sprite = eyes[2];
            iris.Hide();
            yield return Frm(a[i + 1] - a[i]);
            eye.sprite = eyes[1];
            iris.Show();
        }
    }
    WaitForSeconds Frm(int i) { return Wf.Sec(i / 30f); }
    void Sign(string url) {
        if (Song.IsSign)
            General._.PlaySign((Song.data.isSignCirc ? "sign" : "sign2") + "/d" + url);
    }
}
public class General : Singleton<General> {
    [HideInInspector] public int lvlIdx = 0, gameIdx = 0;
    [HideInInspector] public AudioSource src;
    GameObject selectGo, confettiGo, winGo;
    VideoPlayer signVp;
    List<GameObject> lvlBarGos = new List<GameObject>();
    Image lvlBarImg;
    Vector3 winScl;
    Song song;
    AudioClip correctClip, wrongClip;
    MyBido bido;
    int lvlCnt;
    public static int saveLvlIdx {
        get { return PlayerPrefs.GetInt("saveLvlIdx", -1); }
        set { PlayerPrefs.SetInt("saveLvlIdx", value); }
    }
    public static void Crt(Transform tf, GameTp tp, Action replay, Action next, Action<int> select) {
        Mb.Ins(O.Load<General>("General/General"), tf).Init(tp, replay, next, select,
            tp == GameTp.BBHBO7 ? 1 : tp == GameTp.SUBHEM3 || tp == GameTp.SUBHYA3 ? 2 : 3);
    }
    public void Init(GameTp tp, Action replay, Action next, Action<int> select, int lvl) {
        lvlCnt = lvl;
        string tpStr = tp == GameTp.SUBHYA2 ? "SubHya2" : tp == GameTp.SUBHYA4 ? "SubHya4" :
            tp.tS().IsS("BB") ? "Bb" : lvlCnt == 3 ? "Sub3" : "Sub2";
        Song.game = tp;
        bido = new MyBido();
        IO.Init();
        song = new Song("General/Data/", "");
        correctClip = O.LoadClip("General/Data/correct");
        wrongClip = O.LoadClip("General/Data/wrong");
        src = go.Par().Gc<AudioSource>();
        GameObject lbParGo = go.ChildNameGo("LevelBar"), selParGo = go.ChildNameGo("Select"), winParGo = go.ChildNameGo("Win");
        lbParGo.Childs().ForEach(cGo => cGo.Act(cGo.name == tpStr));
        lbParGo.Tlp(Song.data.lbPos);
        lvlBarImg = lbParGo.ChildName<Image>(tpStr, "Fill", "Fill");
        lvlBarImg.fillAmount = 0;
        selParGo.Childs().ForEach(cGo => cGo.Act(cGo.name == tpStr));
        selectGo = selParGo.ChildNameGo(tpStr);
        selectGo.ChildName("Title", "Text").Txt().text = Name.uyeSongo.txt;
        selectGo.ChildName("Title", "Sound").Btn().onClick.AddListener(() => PlaySong(song, false));
        selectGo.ChildName("Done", "Text").Txt().text = Name.duusah.txt;
        selectGo.ChildName("Done").Btn().onClick.AddListener(Celebrate);
        for (int i = 1; i <= lvlCnt; i++) {
            int j = i - 1;
            selectGo.ChildName("Levels", "Level" + i).Btn().onClick.AddListener(() => select(j));
        }
        winParGo.Childs().ForEach(cGo => cGo.Act(tpStr.IsS(cGo.name)));
        winGo = winParGo.ChildGo(tpStr == "Bb" ? 0 : 1);
        winGo.ChildName("Title").Txt().text = Name.amjilttai.txt;
        winGo.ChildName("Replay").Btn().onClick.AddListener(() => replay());
        winGo.ChildName("Next").Btn().onClick.AddListener(() => next());
        winScl = winGo.Tls();
        go.ChildName("Home").Btn().onClick.AddListener(Home);
        confettiGo = go.ChildNameGo("Confetti");
        Sign(ref signVp, go.ChildNameGo("Sign"), Song.data.isSignCirc);
        for (int i = 1; i <= lvlCnt; i++)
            lvlBarGos.Add(go.ChildGo(0, i));
        winGo.Tls(V3.O);
        selectGo.Tls(V3.O);
        VolSpd(1, 1);
    }
    public static void Sign(ref VideoPlayer vp, GameObject go, bool isCirc, float sz = 300, float bor = 5, string colStr = "888888") {
        vp = go.Gc<VideoPlayer>();
        vp.TlpDx(isCirc ? 0 : sz * 0.1f);
        vp.Hide();
        Vector2 sz2 = V2.V(isCirc ? sz : sz * 0.8f, sz);
        vp.Rt().sizeDelta = sz2 + V2.V(bor * 2);
        vp.Child(0).Rt().sizeDelta = sz2;
        vp.Img().color = colStr.Hex();
        vp.targetTexture = O.Load<RenderTexture>("General/Data/Sign" + (isCirc ? "" : "2"));
        vp.Child(0, 0).Gc<RawImage>().texture = vp.targetTexture;
    }
    void Update() {
        Dev.Check();
        if (General.Check(KeyCode.Escape)) General.Home();
        else if (General.Check(KeyCode.BackQuote)) General.Video();
        else if (General.Check(KeyCode.Tab)) General.Game();
        else if (General.Check(KeyCode.Alpha1)) General.Game(0);
        else if (General.Check(KeyCode.Alpha2) && lvlCnt >= 2) General.Game(1);
        else if (General.Check(KeyCode.Alpha3) && lvlCnt >= 3) General.Game(2);
        else if (General.Check(KeyCode.Return)) General.Celebrate();
    }
    public void VolSpd(float vol, float spd) {
        src.volume = vol;
        src.pitch = spd;
        bido.VolSpd(vol, spd);
        signVp.SetDirectAudioVolume(0, vol);
        signVp.playbackSpeed = spd;
    }
    public void LevelBar(float sclTm = 0.2f) {
        for (int i = 0; i < lvlBarGos.Count; i++)
            StaCor(SclCor(lvlBarGos[i].gameObject, lvlBarGos[i].Tls(), V3.V(i == lvlIdx ? 1.2f : 1), sclTm));
    }
    public void LevelBarFill(int i, int cnt) {
        float f = i.F() / cnt, a = lvlBarImg.fillAmount, b = lvlBarGos.Count == 2 ? (lvlIdx == 0 ? f : 1) :
            (lvlIdx == 0 ? f * 0.4f : lvlIdx == 1 ? 0.6f + f * 0.4f : 1);
        StaCor(Cor(t => lvlBarImg.fillAmount = M.Lerp(a, b, t), 0.3f));
    }
    public void PlaySong(Song song, bool useSign = true) {
        if (useSign && song.sign != "")
            PlaySign(song.sign);
        if (song.clip) {
            src.clip = song.clip;
            src.Play();
        }
    }
    public void PlaySign(string sign) {
        if (Song.IsSign) {
            signVp.Show();
            Vid(signVp, false, sign + ".mp4");
            signVp.loopPointReached += a => signVp.Hide();
        }
    }
    public void PlaySong(bool isCorrect) { PlaySong(isCorrect ? correctClip : wrongClip); }
    public void PlaySong(AudioClip clip) {
        src.clip = clip;
        src.Play();
    }
    public static void Home() { SceneManager.LoadScene("Main"); }
    public static void Video() { SceneManager.LoadScene("Video"); }
    public static void Game(int lvlIdx = -1) {
        saveLvlIdx = lvlIdx;
        SceneManager.LoadScene(Song.IsBlind ? "Blind" : PlayerPrefs.GetString("Game"));
    }
    public static void Celebrate() { SceneManager.LoadScene("Celebrate"); }
    float showTm = 0.5f;
    [HideInInspector] public bool isSelect = false;
    public void LevelSelectShow() {
        isSelect = true;
        PlaySong(song, false);
        StaCor(SclCor(selectGo, V3.O, V3.I, showTm, EaseTp.OutSine));
    }
    public IEnumerator SelectLevelCor(LvlData data, System.Action crtData, int idx) {
        yield return SclCor(selectGo, V3.I, V3.O, showTm, EaseTp.InSine);
        lvlIdx = idx;
        yield return LevelShowCor(data, crtData);
        isSelect = false;
    }
    public IEnumerator LevelShowCor(LvlData data, System.Action crtData) {
        confettiGo.Hide();
        crtData();
        if (data.NotNull()) {
            TxtCol(data, showTm, false);
            yield return SclCor(data.go, V3.O, V3.I, showTm, EaseTp.OutSine);
        }
    }
    public IEnumerator LevelHideCor(LvlData data) {
        Win();
        if (data.NotNull())
            yield return SclCor(data.go, V3.I, V3.O, showTm, EaseTp.InSine);
        confettiGo.Show();
    }
    public IEnumerator WinShowCor() { yield return SclCor(winGo, V3.O, winScl, showTm, EaseTp.OutSine); }
    public IEnumerator WinHideCor(LvlData data, System.Action crtData) {
        confettiGo.Hide();
        yield return SclCor(winGo, winScl, V3.O, showTm, EaseTp.InSine);
        yield return LevelShowCor(data, crtData);
    }
    public void TxtCol(LvlData data, float tm, bool isSta) { TxtCol(data.txt, tm, isSta); }
    public void TxtCol(Text txt, float tm, bool isSta) {
        StaCor(Cor(t => txt.color = txt.color.A(isSta ? 1 - t : t), tm, isSta ? EaseTp.InSine : EaseTp.OutSine));
    }
    public void Correct(bool isCorrect) { bido.Correct(isCorrect); }
    public void Good() { bido.Good(); }
    void Win() { bido.Win(); }
    public void Idle(VideoPlayer v = null) { bido.Idle(); }
    public void LvlBar(List<GameObject> stars, bool isUp = false) { LvlBar(stars, isUp ? gameIdx - 1 : gameIdx, isUp); }
    public void LvlBar(List<GameObject> stars, int idx, bool isUp, float tm = 0.2f) {
        for (int i = 0; i < stars.Count; i++) {
            if (i == idx) StaCor(isUp ? SclCor(stars[i], V3.O, V3.I, tm, EaseTp.OutSine) : SclCor(stars[i], V3.I, V3.O, tm, EaseTp.InSine));
            else stars[i].Tls(i < idx ? V3.I : V3.O);
        }
    }
    public void SclTm(List<Transform> tfs, float tm, bool isBig) { SclTm(tfs, tm, isBig, tf => tf.gameObject); }
    public void SclTm(List<RectTransform> tfs, float tm, bool isBig) { SclTm(tfs, tm, isBig, tf => tf.gameObject); }
    public void SclTm<T>(List<T> lis, float tm, bool isBig, System.Func<T, GameObject> func) { SclTm(lis, tm, isBig, V3.zpp, V3.I, func); }
    public void SclTm<T>(List<T> lis, float tm, bool isBig, Vector3 min, Vector3 max, System.Func<T, GameObject> func) {
        foreach (var e in lis) {
            if (isBig) StaCor(SclCor(func(e), min, max, tm, EaseTp.OutSine));
            else StaCor(SclCor(func(e), max, min, tm, EaseTp.InSine));
        }
    }
    static Dictionary<KeyCode, KeyCode> KeyDic = new Dictionary<KeyCode, KeyCode> {
        { KeyCode.BackQuote, KeyCode.Tilde },
        { KeyCode.Alpha1, KeyCode.Exclaim },
        { KeyCode.Alpha2, KeyCode.At },
        { KeyCode.Alpha3, KeyCode.Hash },
        { KeyCode.Alpha4, KeyCode.Dollar },
        { KeyCode.Alpha5, KeyCode.Percent },
        { KeyCode.Alpha6, KeyCode.Caret },
        { KeyCode.Alpha7, KeyCode.Ampersand },
        { KeyCode.Alpha8, KeyCode.Asterisk },
        { KeyCode.Alpha9, KeyCode.LeftParen },
        { KeyCode.Alpha0, KeyCode.RightParen },
        { KeyCode.Minus, KeyCode.Underscore },
        { KeyCode.Equals, KeyCode.Plus },
        { KeyCode.LeftBracket, KeyCode.LeftCurlyBracket },
        { KeyCode.RightBracket, KeyCode.RightCurlyBracket },
        { KeyCode.Backslash, KeyCode.Pipe },
        { KeyCode.Semicolon, KeyCode.Colon },
        { KeyCode.Quote, KeyCode.DoubleQuote },
        { KeyCode.Comma, KeyCode.Less },
        { KeyCode.Period, KeyCode.Greater },
        { KeyCode.Slash, KeyCode.Question },
        { KeyCode.Return, KeyCode.KeypadEnter },
    };
    public static bool Check(KeyCode k) { return Input.GetKeyDown(k) || KeyDic.ContainsKey(k) && Input.GetKeyDown(KeyDic[k]); }
}